<template>
  <el-row>
    <el-col :span="5">
      <div class="box">
        <el-scrollbar>
          <basic-container>
            <avue-tree :option="treeOption" :data="treeData" @node-click="nodeClick"/>
          </basic-container>
        </el-scrollbar>
      </div>
    </el-col>
    <el-col :span="19">
      <basic-container>
        <avue-crud :option="option"
                   :search.sync="search"
                   :table-loading="loading"
                   :data="data"
                   ref="crud"
                   v-model="form"
                   :permission="permissionList"
                   @row-del="rowDel"
                   @row-update="rowUpdate"
                   @row-save="rowSave"
                   :before-open="beforeOpen"
                   :page.sync="page"
                   @search-change="searchChange"
                   @search-reset="searchReset"
                   @selection-change="selectionChange"
                   @current-change="currentChange"
                   @size-change="sizeChange"
                   @refresh-change="refreshChange"
                   @on-load="onLoad">
          <template slot="menuLeft">
            <el-button type="danger"
                       size="small"
                       plain
                       icon="el-icon-delete"
                       v-if="permission.user_delete"
                       @click="handleDelete">刪 除
            </el-button>
            <el-button type="info"
                       size="small"
                       plain
                       v-if="permission.user_role"
                       icon="el-icon-user"
                       @click="handleGrant">角色配置
            </el-button>
            <el-button type="info"
                       size="small"
                       plain
                       v-if="permission.user_reset"
                       icon="el-icon-refresh"
                       @click="handleReset">密碼重置
            </el-button>
            <!-- <el-button type="info"
                        size="small"
                        plain
                        v-if="userInfo.role_name.includes('admin')"
                        icon="el-icon-setting"
                        @click="handlePlatform">平臺配置
             </el-button>-->
            <el-button type="success"
                       size="small"
                       plain
                       v-if="userInfo.role_name.includes('admin')"
                       icon="el-icon-upload2"
                       @click="handleImport">導入
            </el-button>
            <!--<el-button type="warning"
                       size="small"
                       plain
                       v-if="userInfo.role_name.includes('admin')"
                       icon="el-icon-download"
                       @click="handleExport">導出
            </el-button>-->
            <el-button type="primary"
                       size="small"
                       icon="el-icon-download"
                       plain
                       v-if="userInfo.role_name.includes('admin')"
                       @click="handleDownload">下載
            </el-button>
            <el-button type="info"
                       size="small"
                       plain
                       v-if="userInfo.role_name.includes('admin')"
                       icon="el-icon-setting"
                       @click="testVisible = true">驗證測試
            </el-button>
          </template>
          <template slot-scope="{row}"
                    slot="tenantName">
            <el-tag>{{row.tenantName}}</el-tag>
          </template>
          <template slot-scope="{row}"
                    slot="roleName">
            <el-tag>{{row.roleName}}</el-tag>
          </template>
          <template slot-scope="{row}"
                    slot="deptName">
            <el-tag>{{row.deptName}}</el-tag>
          </template>
          <template slot-scope="{row}"
                    slot="userTypeName">
            <el-tag>{{row.userTypeName}}</el-tag>
          </template>
        </avue-crud>
        <el-dialog title="用戶角色配置"
                   append-to-body
                   :visible.sync="roleBox"
                   width="345px">

          <el-tree :data="roleGrantList"
                   show-checkbox
                   check-strictly
                   default-expand-all
                   node-key="id"
                   ref="treeRole"
                   :default-checked-keys="roleTreeObj"
                   :props="props">
          </el-tree>

          <span slot="footer" class="dialog-footer">
            <el-button @click="roleBox = false">取 消</el-button>
            <el-button type="primary"
                       @click="submitRole">確 定</el-button>
          </span>
        </el-dialog>
        <el-dialog title="用戶數據導入"
                   append-to-body
                   :visible.sync="excelBox"
                   width="555px">
          <avue-form :option="excelOption" v-model="excelForm" :upload-after="uploadAfter">
            <template slot="excelTemplate">
              <el-button type="primary" @click="handleTemplate">
                點擊下載<i class="el-icon-download el-icon--right"></i>
              </el-button>
            </template>
          </avue-form>
        </el-dialog>
        <el-dialog title="用戶平臺配置"
                   append-to-body
                   :visible.sync="platformBox">
          <avue-crud :option="platformOption"
                     :table-loading="platformLoading"
                     :data="platformData"
                     ref="platformCrud"
                     v-model="platformForm"
                     :before-open="platformBeforeOpen"
                     :page.sync="platformPage"
                     :permission="platformPermissionList"
                     @row-update="platformRowUpdate"
                     @search-change="platformSearchChange"
                     @search-reset="platformSearchReset"
                     @selection-change="platformSelectionChange"
                     @current-change="platformCurrentChange"
                     @size-change="platformSizeChange"
                     @refresh-change="platformRefreshChange"
                     @on-load="platformOnLoad">
            <template slot-scope="{row}"
                      slot="tenantName">
              <el-tag>{{row.tenantName}}</el-tag>
            </template>
            <template slot-scope="{row}"
                      slot="userTypeName">
              <el-tag>{{row.userTypeName}}</el-tag>
            </template>
          </avue-crud>
        </el-dialog>
      </basic-container>
    </el-col>

    <el-dialog :append-to-body="true" :modal-append-to-body="false" :destroy-on-close="true" :visible.sync="testVisible" title="驗證測試">
      <login-test></login-test>
    </el-dialog>

  </el-row>
</template>

<script>
  import {
    getList,
    getUser,
    getUserPlatform,
    remove,
    update,
    updatePlatform,
    add,
    grant,
    getDownloadList,
    resetPassword
  } from "@/api/system/user";
  import {getDeptTree, getDeptLazyTree, getTree} from "@/api/system/dept";
  import {getRoleTree} from "@/api/system/role";
  import {getPostList} from "@/api/system/post";
  import {mapGetters} from "vuex";
  import website from '@/config/website';
  import {getToken} from '@/util/auth';
  import LoginTest from "./login-test";

  export default {
    components: {LoginTest},
    data() {
      const pwdRule = /^(?![\d]+$)(?![a-zA-Z]+$)(?![^\da-zA-Z]+$).{6,}$/;
      const validatePass = (rule, value, callback) => {
        if (value === '') {
          callback(new Error('請輸入密碼'));
        } else if (!pwdRule.test(value)) {
          callback(new Error("長度至少為6，且需包含數字、英文、符號任2款組合"));
        } else {
          callback();
        }
      };
      const validatePass2 = (rule, value, callback) => {
        if (value === '') {
          callback(new Error('請再次輸入密碼'));
        } else if (!pwdRule.test(value)) {
          callback(new Error("長度至少為6，且需包含數字、英文、符號任2款組合"));
        } else if (value !== this.form.password) {
          callback(new Error('兩次輸入密碼不一致!'));
        } else {
          callback();
        }
      };
      return {
        testVisible: false,

        form: {},
        search:{},
        roleBox: false,
        excelBox: false,
        platformBox: false,
        initFlag: true,
        selectionList: [],
        query: {},
        params: {},
        loading: true,
        platformLoading: false,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        platformPage: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        init: {
          roleTree: [],
          deptTree: [],
        },
        props: {
          label: "title",
          value: "key"
        },
        roleGrantList: [],
        roleTreeObj: [],
        treeDeptId: '',
        treeData: [],
        treeOption: {
          nodeKey: 'id',
          lazy: false,
          treeLoad: function (node, resolve) {
            /*const parentId = (node.level === 0) ? 0 : node.data.id;
            getDeptLazyTree(parentId).then(res => {
              resolve(res.data.data.map(item => {
                return {
                  ...item,
                  leaf: !item.hasChildren
                }
              }))
            });*/
          },
          addBtn: false,
          menu: false,
          size: 'small',
          props: {
            labelText: '標題',
            label: 'title',
            value: 'value',
            children: 'children'
          }
        },
        option: {
          height: 'auto',
          calcHeight: 80,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          selection: true,
          viewBtn: true,
          //dialogType: 'drawer',
          dialogClickModal: false,
          column: [
            {
              label: "登錄帳號",
              prop: "account",
              search: true,
              display: false
            },
            /*{
              label: "所屬租戶",
              prop: "tenantName",
              slot: true,
              display: false
            },*/
            {
              label: "用戶姓名",
              prop: "name",
              search: true,
              display: false
            },
            {
              label: "EHR號",
              prop: "ehr",
              search: true,
              display: false
            },
            {
              label: "Mo碼",
              prop: "code",
              search: true,
              display: false
            },
            {
              label: "所屬角色",
              prop: "roleName",
              slot: true,
              display: false
            },
            {
              label: "所屬部門",
              prop: "deptName",
              slot: true,
              display: false
            },
            {
              label: "是否為ldap用戶",
              prop: "isLdapuser",
              type: "select",
              align: "center",
              display: false,
              search: true,
              // searchSpan: 4,
              searchLabelWidth: 120,
              dicData: [{
                label: '否',
                value: 0
              }, {
                label: '是',
                value: 1
              }],
            },
            {
              label: "用戶平臺",
              prop: "userTypeName",
              slot: true,
              hide: true,
              display: false
            },
            {
              label: "用戶平臺",
              type: "select",
              dicUrl: "/api/blade-system/dict/dictionary?code=user_type",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
              hide: true,
              display: false,
              prop: "userType",
              rules: [{
                required: true,
                message: "請選擇用戶平臺",
                trigger: "blur"
              }]
            },
          ],
          group: [
            {
              label: '基礎信息',
              prop: 'baseInfo',
              icon: 'el-icon-user-solid',
              column: [
                {
                  label: "所屬租戶",
                  prop: "tenantId",
                  type: "tree",
                  dicUrl: "/api/blade-system/tenant/select",
                  props: {
                    label: "tenantName",
                    value: "tenantId"
                  },
                  hide: !website.tenantMode,
                  addDisplay: website.tenantMode,
                  editDisplay: website.tenantMode,
                  viewDisplay: website.tenantMode,
                  rules: [{
                    required: true,
                    message: "請輸入所屬租戶",
                    trigger: "click"
                  }],
                  span: 24,
                },
                {
                  label: "登錄帳號",
                  prop: "account",
                  rules: [{
                    required: true,
                    message: "請輸入登錄帳號",
                    trigger: "blur"
                  }],
                },
                {
                  label: "用戶類型",
                  type: "select",
                  dicUrl: "/api/blade-system/dict/dictionary?code=user_type",
                  props: {
                    label: "dictValue",
                    value: "dictKey"
                  },
                  dataType: "number",
                  slot: true,
                  prop: "userType",
                  disabled: true,
                  display: false,
                  hide: true,
                  rules: [{
                    required: true,
                    message: "請選擇用戶類型",
                    trigger: "blur"
                  }]
                },
                {
                  label: "是否為ldap用戶",
                  prop: "isLdapuser",
                  labelWidth: 120,
                  value: 1,
                  type: "switch",
                  editDisplay: false,
                  dicData: [{
                    label: '否',
                    value: 0
                  }, {
                    label: '是',
                    value: 1
                  }],
                  change: ({value}) => {
                    this.findObject(this.option.group[0].column, "password").addDisplay = value == 0;
                    this.findObject(this.option.group[0].column, "password2").addDisplay = value == 0;
                  },
                },
                 {
                   label: '密碼',
                   prop: 'password',
                   type: 'password',
                   hide: true,
                   addDisplay: false,
                   editDisplay: false,
                   viewDisplay: false,
                   rules: [{required: true, validator: validatePass, trigger: 'blur'}]
                 },
                 {
                   label: '確認密碼',
                   prop: 'password2',
                   type: 'password',
                   hide: true,
                   addDisplay: false,
                   editDisplay: false,
                   viewDisplay: false,
                   rules: [{required: true, validator: validatePass2, trigger: 'blur'}]
                 },
              ]
            },
            {
              label: '詳細信息',
              prop: 'detailInfo',
              icon: 'el-icon-s-order',
              column: [
                /*{
                  label: "用戶昵稱",
                  prop: "name",
                  hide: true,
                  rules: [{
                    required: true,
                    message: "請輸入用戶昵稱",
                    trigger: "blur"
                  }]
                },*/
                {
                  label: "用戶姓名",
                  prop: "name",
                  rules: [{
                    required: true,
                    message: "請輸入輸入用戶姓名",
                    trigger: "blur"
                  }, {
                    min: 2,
                    max: 5,
                    message: '姓名長度在2到5個字符'
                  }]
                },
                /*{
                  label: "手機號碼",
                  prop: "phone",
                  overHidden: true
                },
                {
                  label: "電子郵箱",
                  prop: "email",
                  hide: true,
                  overHidden: true
                },
                {
                  label: "用戶性別",
                  prop: "sex",
                  type: "select",
                  dicData: [
                    {
                      label: "男",
                      value: 1
                    },
                    {
                      label: "女",
                      value: 2
                    },
                    {
                      label: "未知",
                      value: 3
                    }
                  ],
                  hide: true
                },
                {
                  label: "用戶生日",
                  type: "date",
                  prop: "birthday",
                  format: "yyyy-MM-dd HH:mm:ss",
                  valueFormat: "yyyy-MM-dd HH:mm:ss",
                  hide: true
                },
                {
                  label: "帳號狀態",
                  prop: "statusName",
                  hide: true,
                  display: false
                }*/
              ]
            },
            {
              label: '職責信息',
              prop: 'dutyInfo',
              icon: 'el-icon-s-custom',
              column: [
                {
                  label: "用戶Mo碼",
                  prop: "code",
                  rules: [{
                    required: true,
                    message: "請輸入Mo碼",
                    trigger: "click"
                  }, {
                    max: 8,
                    message: '不能超過8個字符'
                  }]
                },
                {
                  label: "EHR號",
                  prop: "ehr",
                  rules: [{
                    required: true,
                    message: "請輸入EHR號",
                    trigger: "click"
                  }, {
                    max: 7,
                    message: '不能超過7個字符'
                  }]
                },
                {
                  label: "所屬角色",
                  prop: "roleId",
                  search: true,
                  multiple: true,
                  type: "tree",
                  dicData: [],
                  props: {
                    label: "title"
                  },
                  checkStrictly: true,
                  slot: true,
                  rules: [{
                    required: true,
                    message: "請選擇所屬角色",
                    trigger: "click"
                  }]
                },
                {
                  label: "所屬部門",
                  prop: "deptId",
                  type: "tree",
                  // multiple: true,
                  search: true,
                  dicData: [],
                  props: {
                    label: "title"
                  },
                  checkStrictly: true,
                  slot: true,
                  rules: [{
                    required: true,
                    message: "請選擇所屬部門",
                    trigger: "click"
                  }]
                },
                /* {
                   label: "所屬崗位",
                   prop: "postId",
                   type: "tree",
                   multiple: true,
                   dicData: [],
                   props: {
                     label: "postName",
                     value: "id"
                   },
                   rules: [{
                     required: true,
                     message: "請選擇所屬崗位",
                     trigger: "click"
                   }],
                 },*/
              ]
            },
          ]
        },
        data: [],
        platformQuery: {},
        platformSelectionList: [],
        platformData: [],
        platformForm: {},
        platformOption: {
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          selection: true,
          viewBtn: true,
          dialogClickModal: false,
          menuWidth: 120,
          editBtnText: '配置',
          column: [
            {
              label: "登錄帳號",
              prop: "account",
              search: true,
              display: false
            },
            {
              label: "所屬租戶",
              prop: "tenantName",
              slot: true,
              display: false
            },
            {
              label: "用戶姓名",
              prop: "realName",
              search: true,
              display: false
            },
            {
              label: "用戶平臺",
              prop: "userTypeName",
              slot: true,
              display: false,
              hide: true
            },
            {
              label: "用戶平臺",
              type: "select",
              dicUrl: "/api/blade-system/dict/dictionary?code=user_type",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
              search: true,
              hide: true,
              display: false,
              disabled: true,
              prop: "userType",
              rules: [{
                required: true,
                message: "請選擇用戶平臺",
                trigger: "blur"
              }]
            },
            {
              label: "用戶拓展",
              prop: "userExt",
              type: "textarea",
              minRows: 8,
              span: 24,
              overHidden: true,
              row: true,
              hide: true,
            },
          ],
        },
        excelForm: {},
        excelOption: {
          submitBtn: false,
          emptyBtn: false,
          column: [
            {
              label: '範本上傳',
              prop: 'excelFile',
              type: 'upload',
              drag: true,
              loadText: '範本上傳中，請稍等',
              span: 24,
              propsHttp: {
                res: 'data'
              },
              tip: '請上傳 .xls,.xlsx 標準格式檔',
              action: "/api/blade-user/import-user"
            },
            {
              label: "數據覆蓋",
              prop: "isCovered",
              type: "switch",
              align: "center",
              width: 80,
              dicData: [
                {
                  label: "否",
                  value: 0
                },
                {
                  label: "是",
                  value: 1
                }
              ],
              value: 0,
              slot: true,
              rules: [
                {
                  required: true,
                  message: "請選擇是否覆蓋",
                  trigger: "blur"
                }
              ]
            },
            {
              label: '範本下載',
              prop: 'excelTemplate',
              formslot: true,
              span: 24,
            }
          ]
        }
      };
    },
    watch: {
      'form.tenantId'() {
        if (this.form.tenantId !== '' && this.initFlag) {
          this.initData(this.form.tenantId);
        }
      },
      'excelForm.isCovered'() {
        if (this.excelForm.isCovered !== '') {
          const column = this.findObject(this.excelOption.column, "excelFile");
          column.action = `/api/blade-user/import-user?isCovered=${this.excelForm.isCovered}`;
        }
      }
    },
    computed: {
      ...mapGetters(["userInfo", "permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.user_add, false),
          viewBtn: this.vaildData(this.permission.user_view, false),
          delBtn: this.vaildData(this.permission.user_delete, false),
          editBtn: this.vaildData(this.permission.user_edit, false)
        };
      },
      platformPermissionList() {
        return {
          addBtn: false,
          viewBtn: false,
          delBtn: false,
          editBtn: this.vaildData(this.permission.user_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      },
    },
    mounted() {
      // 非租戶模式默認加載管理組數據
      if (!website.tenantMode) {
        this.initData(website.tenantId);
      }
    },
    methods: {
      handleDownload(){
        if (this.selectionList.length === 0) {
          let tip = "確定下載篩選的" + this.page.total + "條數據嗎？"
          this.$confirm(tip, {
            confirmButtonText: "確定",
            cancelButtonText: "取消",
            type: "warning"
          })
            .then(() => {
              getDownloadList(this.query, this.treeDeptId).then(res => {
                this.downLoadData(res.data.data, true)
              });
            })
        }else{
          this.downLoadData(this.selectionList, false)
        }
      },
      downLoadData(data, isAll){
        let columns = this.deepClone(this.option.column);
        for (let i = 0; i < columns.length; i++) {
          let item = columns[i];
          if (item.hide || item.prop == 'process'){
            columns.splice(i, 1);
            i--;
          }
          if (!isAll && (item.type == 'select' || item.type == 'tree')){
            item.prop = '$' + item.prop;
          }
        }
        this.$Export.excel({
          title: "用戶信息表" || new Date().getTime(),
          columns: columns,
          data: data
        });
      },
      nodeClick(data) {
        this.treeDeptId = data.id;
        this.params.deptId = data.id;
        this.page.currentPage = 1;
        this.onLoad(this.page);
      },
      initData(tenantId) {
        getRoleTree(tenantId).then(res => {
          const column = this.findObject(this.option.group, "roleId");
          column.dicData = res.data.data;
        });
        getDeptTree(tenantId).then(res => {
          const column = this.findObject(this.option.group, "deptId");
          column.dicData = res.data.data;
          let treeData = getTree(res.data.data, this.userInfo.dept_id);
          this.treeData = treeData;
        });
        /*getPostList(tenantId).then(res => {
          const column = this.findObject(this.option.group, "postId");
          column.dicData = res.data.data;
        });*/
      },
      submitRole() {
        const roleList = this.$refs.treeRole.getCheckedKeys().join(",");
        grant(this.ids, roleList).then(() => {
          this.roleBox = false;
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          this.onLoad(this.page);
        });
      },
      rowSave(row, done, loading) {
        // row.deptId = row.deptId.join(",");
        row.roleId = row.roleId.join(",");
        if (row.postId){
          row.postId = row.postId.join(",");
        }
        add(row).then(() => {
          this.initFlag = false;
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          window.console.log(error);
          loading();
        });
      },
      rowUpdate(row, index, done, loading) {
        // row.deptId = row.deptId.join(",");
        row.roleId = row.roleId.join(",");
        if (row.postId){
          row.postId = row.postId.join(",");
        }
        update(row).then(() => {
          this.initFlag = false;
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          window.console.log(error);
          loading();
        });
      },
      rowDel(row) {
        this.$confirm("確定將選擇數據刪除?", {
          confirmButtonText: "確定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      searchReset() {
        this.query = {};
        this.treeDeptId = '';
        this.params = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.params = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("請選擇至少一條數據");
          return;
        }
        this.$confirm("確定將選擇數據刪除?", {
          confirmButtonText: "確定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      handleReset() {
        if (this.selectionList.length === 0) {
          this.$message.warning("請選擇至少一條數據");
          return;
        }

        let flag = false;
        for (let i = 0; i < this.selectionList.length; i++) {
          let item = this.selectionList[i];
          if (item.isLdapuser);
          flag = flag || item.isLdapuser == 1;
        }
        if (flag){
          this.$message.warning("重置密碼只針對非ldap用戶，請選擇非ldap用戶再進行操作！");
          return;
        }

        this.$confirm("確定將選擇帳號密碼重置為123456?", {
          confirmButtonText: "確定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return resetPassword(this.ids);
          })
          .then(() => {
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      handleGrant() {
        if (this.selectionList.length === 0) {
          this.$message.warning("請選擇至少一條數據");
          return;
        }
        this.roleTreeObj = [];
        if (this.selectionList.length === 1) {
          this.roleTreeObj = this.selectionList[0].roleId.split(",");
        }
        getRoleTree().then(res => {
          this.roleGrantList = res.data.data;
          this.roleBox = true;
        });
      },
      handlePlatform() {
        this.platformBox = true;
      },
      handleImport() {
        this.excelBox = true;
      },
      uploadAfter(res, done, loading, column) {
        window.console.log(column);
        this.excelBox = false;
        this.refreshChange();
        done();
      },
      handleExport() {
        this.$confirm("是否導出用戶數據?", "提示", {
          confirmButtonText: "確定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          window.open(`/api/blade-user/export-user?${this.website.tokenHeader}=${getToken()}&account=${this.search.account}&name=${this.search.name}`);
        });
      },
      handleTemplate() {
        window.open(`/api/blade-user/export-template?${this.website.tokenHeader}=${getToken()}`);
      },
      beforeOpen(done, type) {
        if (type == 'add'){
          this.form.userType = '1';
        }
        if (["edit", "view"].includes(type)) {
          getUser(this.form.id).then(res => {
            this.form = res.data.data;
            /* if(this.form.hasOwnProperty("deptId")){
               this.form.deptId = this.form.deptId.split(",");
             }*/
            if(this.form.hasOwnProperty("roleId")){
              this.form.roleId = this.form.roleId.split(",");
            }
            if(this.form.hasOwnProperty("postId")){
              this.form.postId = this.form.postId.split(",");
            }
          });
        }
        this.initFlag = true;
        done();
      },
      currentChange(currentPage) {
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize) {
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        let deptId = this.treeDeptId;
        if (!this.params.deptId && this.treeDeptId){
          this.params.deptId = deptId;
        }
        getList(page.currentPage, page.pageSize, Object.assign(this.params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      },
      platformRowUpdate(row, index, done, loading) {
        updatePlatform(row.id, row.userType, row.userExt).then(() => {
          this.platformOnLoad(this.platformPage);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          window.console.log(error);
          loading();
        });
      },
      platformBeforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getUserPlatform(this.platformForm.id).then(res => {
            this.platformForm = res.data.data;
          });
        }
        done();
      },
      platformSearchReset() {
        this.platformQuery = {};
        this.platformOnLoad(this.platformPage);
      },
      platformSearchChange(params, done) {
        this.platformQuery = params;
        this.platformPage.currentPage = 1;
        this.platformOnLoad(this.platformPage, params);
        done();
      },
      platformSelectionChange(list) {
        this.platformSelectionList = list;
      },
      platformSelectionClear() {
        this.platformSelectionList = [];
        this.$refs.platformCrud.toggleSelection();
      },
      platformCurrentChange(currentPage) {
        this.platformPage.currentPage = currentPage;
      },
      platformSizeChange(pageSize) {
        this.platformPage.pageSize = pageSize;
      },
      platformRefreshChange() {
        this.platformOnLoad(this.platformPage, this.platformQuery);
      },
      platformOnLoad(page, params = {}) {
        this.platformLoading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query), this.treeDeptId).then(res => {
          const data = res.data.data;
          this.platformPage.total = data.total;
          this.platformData = data.records;
          this.platformLoading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
  .box {
    height: 800px;
  }

  .el-scrollbar {
    height: 100%;
  }

  .box .el-scrollbar__wrap {
    overflow: scroll;
  }
</style>
